unit unitCVS;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids,
  
  LazUtf8, // für SysToUTF8
  LConvEncoding,
  LCLIntf, // für Open URL

  StdCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bt_Ende: TButton;
    Bt_Replace_save: TButton;
    Bt_Replace_Load: TButton;
    Bt_neue_Zeile: TButton;
    Bt_Check_leere_Zeile_loeschen: TButton;
    Bt_Quick_Replace: TButton;
    BT_HelpClose: TButton;
    Bt_Help: TButton;
    Bt_About: TButton;
    Button1: TButton;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Lb_Version: TLabel;
    Lb_Shaped: TLabel;
    Lb01: TLabel;
    Lb_CVS_File_save: TLabel;
    Lb_Replace_File: TLabel;
    Lb_CVS_File_load: TLabel;
    LB_02: TLabel;
    Memo_Help: TMemo;
    Mm_CVS: TMemo;
    OpenDialog1: TOpenDialog;
    Pn_Help: TPanel;
    SaveDialog1: TSaveDialog;
    StringGrid1: TStringGrid;
    procedure Bt_Check_leere_Zeile_loeschenClick(Sender: TObject);
    procedure Bt_EndeClick(Sender: TObject);
    procedure Bt_HelpClick(Sender: TObject);
    procedure Bt_neue_ZeileClick(Sender: TObject);
    procedure Bt_Quick_ReplaceClick(Sender: TObject);
    procedure Bt_Replace_LoadClick(Sender: TObject);
    procedure Bt_Replace_saveClick(Sender: TObject);
    procedure BT_HelpCloseClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure Mm_CVSDblClick(Sender: TObject);
    procedure StringGrid1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    Procedure Zeilennummern_fuellen;
    Function Leerzeile_vermeiden:integer;
    Procedure Neue_Zeile_bilden;
    procedure GridDeleteRow(const Grid : TStringGrid; RowNumber : Integer);
    Procedure Leere_Zeile_loeschen;
    Function String__schreiben ( A_String , A_Pfad : string) : Boolean ;
    Function String_lesen (  A_Pfad : string) : string ;
    Function String_replacen ( A_String : string):string;
    Procedure Programm___beenden;
    Procedure Lesen_Replace_und_schreiben ( A_File_lesen , A_File_schreiben : string);
    Function Sicherungs_File_Pfad_bilden (A_Pfad : string): string;

  private

  public

  end;



var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }





procedure TForm1.StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
begin
  LB_02.Caption := inttostr(aRow);
  Lb01.Caption:=inttostr(StringGrid1.RowCount - 1);
end;

procedure TForm1.BT_HelpCloseClick(Sender: TObject);
begin
    Pn_Help.Visible:=false;
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := false; //Schließen verhindern
  Form1.Programm___beenden;
end;

Function TForm1.String_replacen ( A_String : string ):string;
var
  k : integer;
  a1 , a2  : string;
begin
  Form1.Leere_Zeile_loeschen;
  Result := '';
  for k := 1 to ( StringGrid1.RowCount - 1) do
  begin
       StringGrid1.Cells[1 , k ] := TrimLeft(StringGrid1.Cells[1 , k ]);
       StringGrid1.Cells[1 , k ] := TrimRight(StringGrid1.Cells[1 , k ]);
       a1 := StringGrid1.Cells[1 , k ];
       a2 := StringGrid1.Cells[2 , k ];
       if a1 = '' then // sollte nicht vorkommen
       begin
         StringGrid1.Cells[2 , k ] := '';
         break;
       end;
       A_String := StringReplace( A_String , a1  , a2 , [rfReplaceAll,rfIgnoreCase]);  // falls sowas: |||  drin ist
  end;
  Result := A_String;
end;


Function TForm1.Leerzeile_vermeiden:integer;
var
  sss : string;
  n : integer;
begin
  Result := 0;
  n := strtoint(LB_02.Caption) ;
  if n > 1 then
  begin
    sss := StringGrid1.Cells[1 , (n - 1) ];
    if sss <> '' then Result := 1;
  end
  else
  begin
    Result := 1;
  end;
end;

procedure TForm1.StringGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var
  sss : string;
  n : integer;
begin
   n := strtoint(LB_02.Caption);
   sss := StringGrid1.Cells[1 , n ];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin


           Form1.Top:=20;
           Form1.Left:=20;
           Form1.Width:=1319;
           Form1.Constraints.MaxWidth := Form1.Width;
           Form1.Constraints.MinWidth := Form1.Width;
           Form1.Height:=619;
           Form1.Constraints.MaxHeight := Form1.Height;
           Form1.Constraints.MinHeight := Form1.Height;

           Form1.Pn_Help.Left:=300;
           Form1.Pn_Help.Top:=20;


  Lb_Replace_File.Caption :=  SysToUTF8 ( ExtractFilePath( ExpandFileName(ParamStr(0)) ) )  + 'cvs_replace.txt';

  StringGrid1.RowCount := 10000 ;
  if fileexists(Lb_Replace_File.Caption) then  StringGrid1.LoadFromFile(Lb_Replace_File.Caption);
  Form1.Zeilennummern_fuellen;
  StringGrid1.Cells[1 , 0 ] := '               ... to replace';
  StringGrid1.Cells[2 , 0 ] := '               replaced with ...';
  StringGrid1.TopRow:=1;
end;

procedure TForm1.Mm_CVSDblClick(Sender: TObject);
begin
  Form1.Mm_CVS.Text:='';
end;


Procedure TForm1.Zeilennummern_fuellen;
var
  i , n : integer;
begin
  n := 1;
  i := StringGrid1.RowCount - 1;
  for i := 1 to i do
  begin
    n := n + 1 ;
    if StringGrid1.Cells[1, i] <> '' then
    begin
       StringGrid1.Cells[0, i] := inttostr(i);
    end
    else
    begin
      StringGrid1.Rowcount := n;
      StringGrid1.TopRow:=n;
      StringGrid1.Cells[0 , 0 ] := '';
      exit;
    end;
  end;
end;



procedure TForm1.Bt_neue_ZeileClick(Sender: TObject);
begin
  Form1.Neue_Zeile_bilden;
end;



procedure TForm1.Bt_EndeClick(Sender: TObject);
begin
   Form1.Programm___beenden;
end;

procedure TForm1.Bt_HelpClick(Sender: TObject);
begin
  Pn_Help.Visible:=true;
end;

Procedure TForm1.Programm___beenden;
begin
  String__schreiben ( Mm_CVS.Lines.Text , Lb_CVS_File_save.Caption );
  StringGrid1.SaveToFile(Lb_Replace_File.Caption);
  Application.Terminate;
end;

procedure TForm1.Bt_Replace_LoadClick(Sender: TObject);
begin
   StringGrid1.LoadFromFile(Lb_Replace_File.Caption);
end;

procedure TForm1.Bt_Replace_saveClick(Sender: TObject);
begin
   StringGrid1.SaveToFile(Lb_Replace_File.Caption);
end;


procedure TForm1.Bt_Quick_ReplaceClick(Sender: TObject);
var
  F1 , F2 : string;
begin
  //    Mm_CVS.Text := CP1252ToUTF8(Form1.String_lesen ( OpenDialog1.FileName ));


   Mm_CVS.Text := '';
   if OpenDialog1.Execute then
   begin
     F1 := OpenDialog1.FileName;
     Lb_CVS_File_load.Caption := F1;
     Mm_CVS.Text := Form1.String_lesen ( F1 );

     F2 := Form1.Sicherungs_File_Pfad_bilden ( F1 );
     Lb_CVS_File_save.Caption:=F2;
     Form1.Lesen_Replace_und_schreiben ( F1 , F2 );

     Showmessage( 'File: '+ LineEnding + F1 + LineEnding + ' -->' + LineEnding + F2 + LineEnding + LineEnding +  'Das Ergebnis:');
     Mm_CVS.Text := Form1.String_lesen ( F2 );
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  F1 , F2 : string;
begin
  //    Mm_CVS.Text := CP1252ToUTF8(Form1.String_lesen ( OpenDialog1.FileName ));


   Mm_CVS.Text := '';
   if OpenDialog1.Execute then
   begin
     F1 := OpenDialog1.FileName;
     Lb_CVS_File_load.Caption := F1;
     Mm_CVS.Text := CP1252ToUTF8(Form1.String_lesen ( F1 ));

     F2 := Form1.Sicherungs_File_Pfad_bilden ( F1 );
     Lb_CVS_File_save.Caption:=F2;
     Form1.Lesen_Replace_und_schreiben ( F1 , F2 );

     Showmessage( 'File: '+ LineEnding + F1 + LineEnding + ' -->' + LineEnding + F2 + LineEnding + LineEnding +  'Das Ergebnis:');
     Mm_CVS.Text := CP1252ToUTF8(Form1.String_lesen ( F2 ));
   end;
end;



Function TForm1.Sicherungs_File_Pfad_bilden (A_Pfad : string): string;
var
  sss1 , sss2 : string;
begin
  sss1 := copy( A_Pfad , 1 , (Length(A_Pfad) ) - 4) ;
  sss2 := copy( A_Pfad , ( (Length(A_Pfad) ) - 3 ) , 500 );
  Result := sss1 + '_mod' + sss2;
end;

Procedure TForm1.Lesen_Replace_und_schreiben ( A_File_lesen , A_File_schreiben : string);
var
  ttt : string;
begin
   ttt := Form1.String_lesen ( A_File_lesen );
   ttt := Form1.String_replacen ( ttt );
   String__schreiben ( ttt , A_File_schreiben );

   //OpenURL ( A_File_schreiben );
   //Form1.BringToFront;
   //Application.ProcessMessages;
   // Showmessage('File: '+ LineEnding + A_File_lesen + LineEnding + ' -->' + LineEnding + A_File_schreiben );
end;


Function TForm1.String__schreiben ( A_String , A_Pfad : string) : Boolean ;
var
    A_Stream: TFileStream;
    A_StreamLaenge : integer;
begin
      if DirectoryExists(  SysToUTF8 ( ExtractFilePath ( A_Pfad  )) ) then
      begin
        A_Stream := TFileStream.Create( A_Pfad , fmCreate);
        A_StreamLaenge := length ( A_String );
        try
          A_Stream.Position := 0;
          A_Stream.Write( A_String[1] , A_StreamLaenge );
        finally
          A_Stream.Free;
        end;
        Result := true;
      end;
end;


Function TForm1.String_lesen (  A_Pfad : string) : string ;
var
    Datei: TFileStream;
begin
     Result := '';
     try
        Datei := TFileStream.Create( A_Pfad ,fmOpenRead);
        Result := StringOfChar(#00,Datei.Size);
        Datei.Read(Result[1], Datei.Size);
     finally
        Datei.Free;
     end;
end;

procedure TForm1.Bt_Check_leere_Zeile_loeschenClick(Sender: TObject);
begin
    Form1.Leere_Zeile_loeschen;
end;


Procedure TForm1.Leere_Zeile_loeschen;
var
  i , xx , zz , A_Row: integer;
Label
  Sprung1 , Sprung2 ;
begin
    A_Row := StringGrid1.Row;
    Sprung1:
    i := StringGrid1.RowCount - 1;
    zz := i;
    for i := 1 to i do
    begin
      if StringGrid1.Cells[1, i] = '' then
      begin
         GridDeleteRow(StringGrid1, i);
         goto Sprung2;
      end;
    end;

    Sprung2:
    xx := StringGrid1.RowCount - 1;
    if xx = zz then
    begin
      Form1.Zeilennummern_fuellen;
      Form1.Neue_Zeile_bilden;
      StringGrid1.SetFocus;
      StringGrid1.Row:= A_Row;
      exit;
    end;
    goto Sprung1;
end;

Procedure TForm1.Neue_Zeile_bilden;
begin
  if StringGrid1.cells[1,StringGrid1.Rowcount-1] <> '' then StringGrid1.Rowcount:= StringGrid1.Rowcount + 1;
  Form1.Zeilennummern_fuellen;
  StringGrid1.SetFocus;
  StringGrid1.Row:= StringGrid1.RowCount; // darf größer sein als vorhandene Zeilen: springt zur Letzten
end;



procedure TForm1.GridDeleteRow(const Grid : TStringGrid; RowNumber : Integer);
var
  i : Integer;
begin
  for i := RowNumber to Grid.RowCount - 2 do
    Grid.Rows[i].Assign(Grid.Rows[i+ 1]);
  Grid.Rows[Grid.RowCount-1].Clear;
  Grid.RowCount := Grid.RowCount - 1;
end;





end.

